Last Comment Bug 780976 - linux external api builds broken (hidden symbol `MOZ_Z_inflate' isn't defined) since bug 763651
: linux external api builds broken (hidden symbol `MOZ_Z_inflate' isn't defined...
Status: RESOLVED FIXED
:
Product: MailNews Core
Classification: Components
Component: Build Config (show other bugs)
: Trunk
: x86_64 Linux
: -- normal (vote)
: Thunderbird 17.0
Assigned To: Magnus Melin
:
Mentors:
Depends on:
Blocks: 763651
  Show dependency treegraph
 
Reported: 2012-08-07 13:02 PDT by Magnus Melin
Modified: 2012-08-23 09:01 PDT (History)
4 users (show)
bugzillamozillaorg_serge_20140323: in‑testsuite-
See Also:
Crash Signature:
(edit)
QA Whiteboard:
Iteration: ---
Points: ---


Attachments
proposed fix (997 bytes, patch)
2012-08-08 10:51 PDT, Magnus Melin
neil: review+
mkmelin+mozilla: feedback+
Details | Diff | Review
(Bv1) Remove renamed/duplicated ZLIB_LIBS use [Checked in: Comment 20] (725 bytes, patch)
2012-08-23 04:40 PDT, Serge Gautherie (:sgautherie)
neil: review+
mkmelin+mozilla: feedback+
Details | Diff | Review

Description Magnus Melin 2012-08-07 13:02:14 PDT
nsImportModule.cpp
c++ -o nsImportModule.o -c -I../../../mozilla/dist/stl_wrappers -I../../../mozilla/dist/system_wrappers -include /opt/comm-central/src/mozilla/config/gcc_hidden.h -DMOZ_GLUE_IN_PROGRAM -DMOZ_THUNDERBIRD=1 -DOSTYPE=\"Linux3.2\" -DOSARCH=Linux -I/opt/comm-central/src/mailnews/import/build/../src -I/opt/comm-central/src/mailnews/import/build/../text/src -I/opt/comm-central/src/mailnews/import/build/../vcard/src  -I/opt/comm-central/src/mailnews/import/build -I. -I../../../mozilla/dist/include -I../../../mozilla/dist/include/nsprpub  `/opt/moz-objdir/mail/mozilla/dist/sdk/bin/nspr-config --prefix=/opt/moz-objdir/mail/mozilla/dist --includedir=/opt/moz-objdir/mail/mozilla/dist/include/nspr --cflags` -I/opt/moz-objdir/mail/mozilla/dist/include/nss      -fPIC  -pedantic -Wall -Wpointer-arith -Woverloaded-virtual -Werror=return-type -Wtype-limits -Wempty-body -Wno-ctor-dtor-privacy -Wno-overlength-strings -Wno-invalid-offsetof -Wno-variadic-macros -Wcast-align -Wno-long-long -fno-exceptions -fno-strict-aliasing -fno-rtti -ffunction-sections -fdata-sections -fno-exceptions -std=gnu++0x -pthread -pipe  -DNDEBUG -DTRIMMED -g -fno-omit-frame-pointer    -DMOZILLA_CLIENT -include ../../../comm-config.h -MD -MF .deps/nsImportModule.pp /opt/comm-central/src/mailnews/import/build/nsImportModule.cpp
rm -f libimport.so
/usr/bin/python2.7 /opt/comm-central/src/mozilla/config/pythonpath.py -I../../../mozilla/config /opt/comm-central/src/mozilla/config/expandlibs_exec.py --depend .deps/libimport.pp --target libimport.so --uselist --  c++  -pedantic -Wall -Wpointer-arith -Woverloaded-virtual -Werror=return-type -Wtype-limits -Wempty-body -Wno-ctor-dtor-privacy -Wno-overlength-strings -Wno-invalid-offsetof -Wno-variadic-macros -Wcast-align -Wno-long-long -fno-exceptions -fno-strict-aliasing -fno-rtti -ffunction-sections -fdata-sections -fno-exceptions -std=gnu++0x -pthread -pipe  -DNDEBUG -DTRIMMED -g -fno-omit-frame-pointer  -fPIC -shared -Wl,-z,defs -Wl,--gc-sections -Wl,-h,libimport.so -o libimport.so  nsImportModule.o     -lpthread    -Wl,-rpath-link,/opt/moz-objdir/mail/mozilla/dist/bin:/usr/lib:/usr/local/lib:/lib -Wl,-rpath-link,/usr/local/lib   ../src/libimport_s.a ../text/src/libimptext_s.a ../vcard/src/libimpvcard_s.a  ../../base/util/libmsgbsutl_s.a -L../../../mozilla/dist/bin -L../../../mozilla/dist/lib -L/opt/moz-objdir/mail/mozilla/dist/bin -ljs_static /opt/moz-objdir/mail/mozilla/dist/lib/libxpcomglue_s.a -L/opt/moz-objdir/mail/mozilla/dist/bin -lxpcom -lmozalloc /opt/moz-objdir/mail/mozilla/dist/lib/libunicharutil_external_s.a ../../../mozilla/rdf/util/src/librdfutil_external_s.a `/opt/moz-objdir/mail/mozilla/dist/sdk/bin/nspr-config --prefix=/opt/moz-objdir/mail/mozilla/dist --libdir=/opt/moz-objdir/mail/mozilla/dist/lib --libs` -L/opt/moz-objdir/mail/mozilla/dist/bin -lxpcom -lmozalloc -lxul   -Wl,--version-script -Wl,/opt/comm-central/src/mozilla/build/unix/gnu-ld-scripts/components-version-script -Wl,-Bsymbolic -ldl -lm    
/usr/bin/ld: libimport.so: hidden symbol `MOZ_Z_inflate' isn't defined
/usr/bin/ld: final link failed: Bad value
collect2: ld returned 1 exit status
make[7]: *** [libimport.so] Error 1
make[7]: Leaving directory `/opt/moz-objdir/mail/mailnews/import/build'
make[6]: *** [libs] Error 2
make[6]: Leaving directory `/opt/moz-objdir/mail/mailnews/import'
make[5]: *** [libs] Error 2
make[5]: Leaving directory `/opt/moz-objdir/mail/mailnews'
make[4]: *** [libs_tier_app] Error 2
make[4]: Leaving directory `/opt/moz-objdir/mail'
make[3]: *** [tier_app] Error 2
make[3]: Leaving directory `/opt/moz-objdir/mail'
make[2]: *** [default] Error 2
make[2]: Leaving directory `/opt/moz-objdir/mail'
make[1]: *** [build] Error 2
make[1]: Leaving directory `/opt/comm-central/src'
make: *** [build] Error 2

Maybe this was bug 773967 for windows?
Comment 1 neil@parkwaycc.co.uk 2012-08-07 13:14:08 PDT
I guess we need to copy the ifneq block from mailnews/build/Makefile.in which wasn't necessary for import at the time?
Comment 2 Magnus Melin 2012-08-08 10:51:51 PDT
Created attachment 650205 [details] [diff] [review]
proposed fix

Thx, that builds!!
Comment 3 neil@parkwaycc.co.uk 2012-08-08 14:10:33 PDT
My external build completed, so I can't tell whether the patch is necessary...
Comment 4 Magnus Melin 2012-08-08 22:38:35 PDT
Mine didn't, and that's the only thing i changed. Compiling on ubuntu. Maybe it's picking up system zlib (vs not)? I didn't set any special options for it. My build foo is really weak :/
Comment 5 neil@parkwaycc.co.uk 2012-08-09 00:40:53 PDT
That shouldn't make any difference because we're not including either zlib in import's Makefile, but you can always grep $objdir/config/autoconf.mk for ZLIB to see what your settings are.
Comment 6 Magnus Melin 2012-08-09 11:43:40 PDT
Yeah it says MOZ_NATIVE_ZLIB	=
Comment 7 Magnus Melin 2012-08-15 11:02:11 PDT
Still broken without the patch. 
Did you really build thunderbird, not seamonkey? If so, maybe there's some difference?

I don't use much special options:
ac_add_options --disable-optimize
ac_add_options --disable-installer
ac_add_options --disable-crashreporter
ac_add_options --disable-debug

ac_add_options --enable-incomplete-external-linkage
ac_add_options --enable-incomplete-toolkit-ldap-autocomplete
Comment 8 neil@parkwaycc.co.uk 2012-08-15 13:01:51 PDT
Just to be sure, I made a build with exactly those options, and it completed.

I am however using gcc 4.7, I wonder whether that makes a difference?
Comment 9 Magnus Melin 2012-08-16 12:11:31 PDT
I don't know if it would make a difference, but my gcc is 4.6.3.
Comment 10 Mozilla RelEng Bot 2012-08-17 04:00:25 PDT
Try run for dd60703e3263 is complete.
Detailed breakdown of the results available here:
    https://tbpl.mozilla.org/?tree=Try&rev=dd60703e3263
Results (out of 4 total builds):
    failure: 4
Builds (or logs if builds failed) available at:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/neil@parkwaycc.co.uk-dd60703e3263
Comment 11 neil@parkwaycc.co.uk 2012-08-17 04:40:42 PDT
First try run used an old revision that doesn't build with trunk m-c. Oops.
Second try run failed with the hidden symbol error! Woohoo!
Third try run has the patch applied... fingers crossed!
Comment 12 Mozilla RelEng Bot 2012-08-17 04:45:26 PDT
Try run for 0498141552f0 is complete.
Detailed breakdown of the results available here:
    https://tbpl.mozilla.org/?tree=Try&rev=0498141552f0
Results (out of 4 total builds):
    failure: 4
Builds (or logs if builds failed) available at:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/neil@parkwaycc.co.uk-0498141552f0
Comment 13 Mozilla RelEng Bot 2012-08-17 07:15:27 PDT
Try run for 32f93664304c is complete.
Detailed breakdown of the results available here:
    https://tbpl.mozilla.org/?tree=Try&rev=32f93664304c
Results (out of 6 total builds):
    success: 2
    warnings: 4
Builds (or logs if builds failed) available at:
http://ftp.mozilla.org/pub/mozilla.org/firefox/try-builds/neil@parkwaycc.co.uk-32f93664304c
Comment 14 neil@parkwaycc.co.uk 2012-08-17 07:39:18 PDT
Comment on attachment 650205 [details] [diff] [review]
proposed fix

Still don't understand why my local build doesn't complain, but this works ;-)
Comment 16 Serge Gautherie (:sgautherie) 2012-08-19 00:45:09 PDT
Comment on attachment 650205 [details] [diff] [review]
proposed fix

>+++ b/mailnews/import/build/Makefile.in
>@@ -82,16 +82,22 @@ EXTRA_DSO_LDOPTS += \
>+ifneq (WINNT,$(OS_ARCH))
>+EXTRA_DSO_LDOPTS += \
>+	$(ZLIB_LIBS) \
>+	$(MOZ_ZLIB_LIBS) \
>+	$(NULL)
>+endif

Iiuc, ZLIB_LIBS should be removed (now), as bug 781446 comment 11 landed just before and renamed it to MOZ_ZLIB_LIBS.
Comment 17 Magnus Melin 2012-08-22 12:12:27 PDT
Comment on attachment 650205 [details] [diff] [review]
proposed fix

i think so, yes
Comment 18 Serge Gautherie (:sgautherie) 2012-08-23 04:40:41 PDT
Created attachment 654573 [details] [diff] [review]
(Bv1) Remove renamed/duplicated ZLIB_LIBS use
[Checked in: Comment 20]
Comment 19 Magnus Melin 2012-08-23 06:23:45 PDT
Comment on attachment 654573 [details] [diff] [review]
(Bv1) Remove renamed/duplicated ZLIB_LIBS use
[Checked in: Comment 20]

Review of attachment 654573 [details] [diff] [review]:
-----------------------------------------------------------------

Can't give an official review, but it works for me.
Comment 20 Serge Gautherie (:sgautherie) 2012-08-23 09:01:09 PDT
Comment on attachment 654573 [details] [diff] [review]
(Bv1) Remove renamed/duplicated ZLIB_LIBS use
[Checked in: Comment 20]

https://hg.mozilla.org/comm-central/rev/4da67e2b1064

Note You need to log in before you can comment on or make changes to this bug.